
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CompaniesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const companies = await db.companies.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        legal_name: data.legal_name
        ||
        null
            ,
            
        tax_number: data.tax_number
        ||
        null
            ,
            
        website: data.website
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
        address_line1: data.address_line1
        ||
        null
            ,
            
        address_line2: data.address_line2
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        state_region: data.state_region
        ||
        null
            ,
            
        postal_code: data.postal_code
        ||
        null
            ,
            
        country: data.country
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        timezone: data.timezone
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await companies.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return companies;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const companiesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                legal_name: item.legal_name
            ||
            null
            ,
            
                tax_number: item.tax_number
            ||
            null
            ,
            
                website: item.website
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
                address_line1: item.address_line1
            ||
            null
            ,
            
                address_line2: item.address_line2
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                state_region: item.state_region
            ||
            null
            ,
            
                postal_code: item.postal_code
            ||
            null
            ,
            
                country: item.country
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                timezone: item.timezone
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const companies = await db.companies.bulkCreate(companiesData, { transaction });

        // For each item created, replace relation files
        

        return companies;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const companies = await db.companies.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.legal_name !== undefined) updatePayload.legal_name = data.legal_name;
        
        
        if (data.tax_number !== undefined) updatePayload.tax_number = data.tax_number;
        
        
        if (data.website !== undefined) updatePayload.website = data.website;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        if (data.address_line1 !== undefined) updatePayload.address_line1 = data.address_line1;
        
        
        if (data.address_line2 !== undefined) updatePayload.address_line2 = data.address_line2;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.state_region !== undefined) updatePayload.state_region = data.state_region;
        
        
        if (data.postal_code !== undefined) updatePayload.postal_code = data.postal_code;
        
        
        if (data.country !== undefined) updatePayload.country = data.country;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.timezone !== undefined) updatePayload.timezone = data.timezone;
        
        
        updatePayload.updatedById = currentUser.id;

        await companies.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await companies.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return companies;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const companies = await db.companies.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of companies) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of companies) {
                await record.destroy({transaction});
            }
        });


        return companies;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const companies = await db.companies.findByPk(id, options);

        await companies.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await companies.destroy({
            transaction
        });

        return companies;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const companies = await db.companies.findOne(
            { where },
            { transaction },
        );

        if (!companies) {
            return companies;
        }

        const output = companies.get({plain: true});

        
        
        
        
        
        
        output.plants_company = await companies.getPlants_company({
            transaction
        });
        
        
        output.suppliers_company = await companies.getSuppliers_company({
            transaction
        });
        
        
        output.customers_company = await companies.getCustomers_company({
            transaction
        });
        
        
        output.items_company = await companies.getItems_company({
            transaction
        });
        
        
        output.boms_company = await companies.getBoms_company({
            transaction
        });
        
        
        
        
        
        output.lots_company = await companies.getLots_company({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        output.qa_inspection_plans_company = await companies.getQa_inspection_plans_company({
            transaction
        });
        
        
        
        
        
        
        
        output.documents_company = await companies.getDocuments_company({
            transaction
        });
        
        
        output.audit_events_company = await companies.getAudit_events_company({
            transaction
        });
        
        
        
        output.organizations = await companies.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.legal_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'legal_name',
                        filter.legal_name,
                    ),
                };
            }
            
            if (filter.tax_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'tax_number',
                        filter.tax_number,
                    ),
                };
            }
            
            if (filter.website) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'website',
                        filter.website,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            
            if (filter.address_line1) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'address_line1',
                        filter.address_line1,
                    ),
                };
            }
            
            if (filter.address_line2) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'address_line2',
                        filter.address_line2,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.state_region) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'state_region',
                        filter.state_region,
                    ),
                };
            }
            
            if (filter.postal_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'postal_code',
                        filter.postal_code,
                    ),
                };
            }
            
            if (filter.country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'country',
                        filter.country,
                    ),
                };
            }
            
            if (filter.timezone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'companies',
                        'timezone',
                        filter.timezone,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.companies.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'companies',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.companies.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

